<template>
  <single-pane :capt="dictionaryRu.title">
    <data-grid
      v-model="searchValue"
      :dataGridRefName="dataGridRefName"
      ref="dataGrid"
      :paging-opt="pagingOpt"
      :add-button="true"
      :add-button-text="dictionaryRu.addButtonTitle"
      @add="onAdd"
      :columns="columns"
      :source="dataSource"
      :hide-grouping-setting="true"
      :hide-sorting-setting="true"
      :remote-operations="remoteOperations"
      @selected="onSelectionItem"
    >
      <div slot="footer">
        <span>{{dictionaryRu.recordsNumber}} {{totalCount}}</span>
      </div>
    </data-grid>

    <ob-modal
      ref="viewItem"
      :title="dictionaryRu.modal.title"
      custom-class="modal-md"
      :data-grid="$refs.dataGrid"
      :is-show-pagination="!newStatus"
      :is-show-controls="false"
    >
      <requisite-popup
        :data-source="selectedData"
        @save="onSaveForm"
        @close="onCloseForm"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import DataGrid       from 'common-components/src/obComponents/obDataGrid';
import ObModal        from 'common-components/src/obComponents/obModal';
import RequisitePopup from './modal/index';
import moment         from 'moment';
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary } from '@/translations/ru/dictionaries__sb_dictionaries__requisite_groups';

export default {
  name: 'RequisitesIndex',
  components: {
    RequisitePopup,
    ObModal,
    DataGrid
  },
  mixins: [],
  computed: {
    columns() {
      return [
        {
          title: this.dictionaryRu.columns.name,
          field: 'title'
        },
        {
          title: this.dictionaryRu.columns.entity,
          field: 'type',
          calculateCellValue: data => {
            return this.objectType[data.type.toUpperCase()];
          }
        },
        {
          title: this.dictionaryRu.columns.number,
          field: 'pos'
        },
        {
          title: this.dictionaryRu.columns.status,
          field: 'is_active',
          calculateCellValue: data => {
            return data.is_active
              ? this.dictionaryRu.status.active
              : this.dictionaryRu.status.inactive;
          }
        },
        {
          title: this.dictionaryRu.columns.date,
          field: 'created_at',
          calculateCellValue(data) {
            return data.created_at
              ? moment(data.created_at).format('DD.MM.YYYY')
              : '';
          }
        }
      ];
    },
    objectType() {
      return {
        PARTICIPANT: this.dictionaryRu.objectType.participant,
        RESOURCE: this.dictionaryRu.objectType.resource
      };
    }
  },
  mounted() {
    this.loadData();
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault),
      selectedData: {},
      dataGridRefName: 'requisitesList',
      api: {
        source: 'card_field',
        method: 'getRequisiteGroups'
      }
    };
  }
};
</script>